#!/usr/bin/perl

use Benchmark qw(cmpthese);
use CGI::Ex::Dump qw(debug);
CGI::Ex::Dump::set_deparse();
my $n = -2;

sub one {
  my $self = shift;
  my $foo  = shift;
  my $str  = "$foo";
}
sub two {
  my ($self, $foo) = @_;
  my $str  = "$foo";
}
sub one_2 {
  my $self = shift;
  my $foo  = shift;
  my $bar  = shift;
  my $baz  = shift;
  my $bee  = shift;
  my $boo  = shift;
  my $buf  = shift;
  my $str  = "$foo$bar$baz$bee$boo$buf";
}
sub two_2 {
  my ($self, $foo, $bar, $baz, $bee, $boo, $buf) = @_;
  my $str  = "$foo$bar$baz$bee$boo$buf";
}
sub one_3 {
  my $self = shift;
}
sub two_3 {
  my ($self) = @_;
}

cmpthese($n, {
  one_1 => sub {
    one({}, 'foo');
  },
  two_1 => sub {
    two({}, 'foo');
  },
  one_2 => sub {
    one_2({}, 'foo', 2, 4, 'fiveola', 'wow', 'caramba'x10);
  },
  two_2 => sub {
    two_2({}, 'foo', 2, 4, 'fiveola', 'wow', 'caramba'x10);
  },
  one_3 => sub {
    one_3({});
  },
  two_3 => sub {
    two_3({});
  },
}, 'auto');

__END__

[pauls@localhost perl]$ perl ui/bench/args.pl
Benchmark: running one_1, one_2, one_3, two_1, two_2, two_3 for at least 2 CPU seconds...
     one_1:  3 wallclock secs ( 2.09 usr +  0.00 sys =  2.09 CPU) @ 314277.99/s (n=656841)
     one_2:  3 wallclock secs ( 2.06 usr +  0.01 sys =  2.07 CPU) @ 118719.81/s (n=245750)
     one_3:  2 wallclock secs ( 2.00 usr +  0.00 sys =  2.00 CPU) @ 522920.00/s (n=1045840)
     two_1:  2 wallclock secs ( 1.99 usr +  0.01 sys =  2.00 CPU) @ 336279.00/s (n=672558)
     two_2:  1 wallclock secs ( 2.01 usr +  0.00 sys =  2.01 CPU) @ 139204.98/s (n=279802)
     two_3:  3 wallclock secs ( 2.16 usr +  0.00 sys =  2.16 CPU) @ 490115.74/s (n=1058650)
          Rate one_2 two_2 one_1 two_1 two_3 one_3
one_2 118720/s    --  -15%  -62%  -65%  -76%  -77%
two_2 139205/s   17%    --  -56%  -59%  -72%  -73%
one_1 314278/s  165%  126%    --   -7%  -36%  -40%
two_1 336279/s  183%  142%    7%    --  -31%  -36%
two_3 490116/s  313%  252%   56%   46%    --   -6%
one_3 522920/s  340%  276%   66%   56%    7%    --
[pauls@localhost perl]$
