package UI::All::Base::FileDialog;

use vars qw(%VALID);

BEGIN {
  %VALID = (
            open_file  => 'Choose a file to open...',
            open_files => 'Select files to open ...',
            choose_dir => 'Choose a directory ...',
            save_file  => 'Save file as ...',
            );
}

sub default_action { 'open_file' }

sub valid_action {
  my ($self, $action) = @_;
  return exists $VALID{$action};
}

sub default_title {
  my ($self, $action) = @_;
  return $VALID{$action} || die "Invalid action \"$action\"";
}

1;

=head1 NAME

UI::All::Base::FileDialog - shared code for FileDialogs

=cut
