package UI::All::Gtk2::FileDialog;

use strict;
use vars qw(%ACTIONS);
use base qw(UI::All::Gtk2 UI::All::Base::FileDialog);
use UI::Signals signals => {
  file_selected  => '',
  files_selected => '',
};
use Gtk2;

BEGIN {
  %ACTIONS = (
    open_file  => 'open',
    open_files => 'open',
    save_file  => 'save',
    choose_dir => 'select_folder',
  );
};

sub attach_proxy {}

sub init_proxy {
  my $self = shift;
  my $parent = $self->parent_widget;
  my $action = delete($self->{'action'}) || '';
  $action    = $self->default_action if ! $self->valid_action($action);
  $self->{'title'} ||= $self->default_title($action);
  $self->add_property('action', $action);
  $self->proxy = Gtk2::FileChooserDialog->new('',
                                              $parent->proxy,
                                              $ACTIONS{$self->{'action'}},
                                              '_Cancel' => 'cancel',
                                              '_OK' => 'ok',
                                              );
  $parent->add_child($self);
}

sub set_dir      { shift->proxy->set_current_folder(shift) }
sub set_file     { return; shift->proxy->set_filename(shift) }
#sub set_file     { shift->proxy->set_current_name(shift) }
sub set_title    { shift->proxy->set_title(shift) }

sub get_filename {
  my $self = shift;
  $self->parent_widget->remove_child($self);
  $self->proxy->set_select_multiple(1) if $self->action eq 'open_files';
  if ($self->proxy->run eq 'ok') {
    if ($self->action eq 'open_files') {
      my $files = $self->proxy->get_filenames;
      $self->proxy->destroy;
      # TODO - emit signal
      return $files;
    } else {
      my $file  = $self->proxy->get_filename;
      $self->proxy->destroy;
      # TODO - emit signal
      return $file;
    }
  } else {
    $self->proxy->destroy;
    return undef;
  }
}

*get_filenames = \&get_filename;

1;
