package UI::All::Tk::Table;

use strict;
use base qw(UI::All::Tk);

use Tk::Table;

sub init_proxy {
  my $self = shift;
  $self->proxy = $self->parent_widget->proxy->Table(-rows       => $self->{rows},
                                                    -columns    => $self->{cols},
                                                    -scrollbars => 'osoe',
                                                    -takefocus  => 1,
                                                    );
  $self->parent_layout->add_widget($self);
  $self->add_property('items', {});
}

sub set_text {
  my ($self, $row, $col, $text) = @_;
  $self->proxy->put($row, $col, $text);
}

sub text {
  my ($self, $row, $col) = @_;
  return $self->proxy->get($row, $col)->cget('-text');
}

1;
