#!/usr/bin/perl -w

use vars qw($one_at_a_time);
use strict;
use UI::All;

my $mw   = UI::All->MainWindow(title => "Run 1");
my $vbox = $mw->LayoutVBox;
my $lb1   = $vbox->ListBox;
my $lb2   = $vbox->ListBox;
$vbox->Button(text => 'Quit',
              clicked => sub { $mw->exit_loop },
              );

$lb1->attach(changed => sub { update_other($lb1, $lb2) });
$lb2->attach(changed => sub { update_other($lb2, $lb1) });

my $items = [qw(foo bar baz one two three)];
$lb1->insert($items);
$lb2->insert($items);
$mw->main_loop;

sub update_other {
  return if $one_at_a_time;
  local $one_at_a_time = 1; # keep from nested signal calling

  my ($old, $new) = @_;
  $new->set_selection(0, $new->selection); # turn off all old ones
  $new->set_selection(1, $old->selection);
  print $old->get($old->selection)."\n";
}
exit;

