#!/usr/bin/perl -w

use strict;
use SDL::App;
use SDL::Rect;
use SDL::Color;

# change these values as necessary
my $title                                = 'My SDL Animation';
my ($width,      $height,      $depth)   = (  640,  480,   16 );
my ($bg_r,       $bg_g,        $bg_b)    = ( 0x00, 0x00, 0x00 );
my ($rect_r,     $rect_g,      $rect_b)  = ( 0x00, 0x00, 0xff ); 
my ($rect_width, $rect_height, $rect_y)  = (  100,  100,  190 );

my $app = SDL::App->new(
                        -width  => $width,
                        -height => $height,
                        -depth  => $depth,
                        );

my $color = SDL::Color->new(
                            -r => $rect_r,
                            -g => $rect_g,
                            -b => $rect_b,
                            );

my $bg_color = SDL::Color->new(
                               -r => $bg_r,
                               -g => $bg_g,
                               -b => $bg_b,
                               );

my $background = SDL::Rect->new(
                                -width  => $width,
                                -height => $height,
                                );

my $rect = create_rect();

# your code here, perhaps
for my $x (0 .. 640) {
  $rect->x( $x );
  draw_frame( $app,
              bg   => $background, bg_color   => $bg_color,
              rect => $rect,       rect_color => $color,
              );
}

# remove this line
sleep 2;

# XXX - if you know why I need to create a new rect here, please tell me!
$rect        = create_rect();
my $old_rect = create_rect();

# your code also here, perhaps
for my $x (0 .. 640) {
  $rect->x( $x );
  draw_undraw_rect( $app,
                    rect       => $rect,  old_rect => $old_rect,
                    rect_color => $color, bg_color => $bg_color, 
                    );
  $old_rect->x( $x );
}

# your code almost certainly follows; remove this line
sleep 2;

sub create_rect {
  return SDL::Rect->new(
                        -height => $rect_height,
                        -width  => $rect_width,
                        -x      => 0,
                        -y      => $rect_y,
                        );
}

sub draw_frame {
  my ($app, %args) = @_;

  $app->fill(   $args{bg},   $args{bg_color}   );
  $app->fill(   $args{rect}, $args{rect_color} );
  $app->update( $args{bg} );
}

sub draw_undraw_rect {
  my ($app, %args) = @_;

  $app->fill(   $args{old_rect}, $args{bg_color}   );
  $app->fill(   $args{rect},     $args{rect_color} );
  $app->update( $args{old_rect} );
  $app->update( $args{rect} );
}
